import * as T from "./Types";
import * as I from "./Interfaces"

export interface Exporter<T = {}>{
    name: T.Name
    exportRPCs() : T.RPC<T>[]
}

export interface Socket extends Destroyable {
    port: number
    hook: (rpcname: T.Name, ...args: T.Any[]) => I.Socket
    unhook: (rpcname:T.Name) => I.Socket
    call: (rpcname:T.Name, ...args: T.Any[]) => Promise<T.Any>
    fire: (rpcname:T.Name, ...args: T.Any[]) => Promise<T.Any>
    on: T.OnFunction    
    close() : void
}

export interface Destroyable{
    destroy() : void
}